with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IHTMLStyleSheetRule_Interface is

   procedure Initialize (This : in out IHTMLStyleSheetRule_Type) is
   begin
      Set_IID (This, IID_IHTMLStyleSheetRule);
   end Initialize;

   function Pointer (This : IHTMLStyleSheetRule_Type)
     return Pointer_To_IHTMLStyleSheetRule
   is
   begin
      return To_Pointer_To_IHTMLStyleSheetRule (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLStyleSheetRule_Type;
                     Pointer : in     Pointer_To_IHTMLStyleSheetRule)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_selectorText
     (This : IHTMLStyleSheetRule_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_selectorText
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_selectorText;

   function Get_selectorText
     (This : IHTMLStyleSheetRule_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_selectorText
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_selectorText;

   function Get_style
     (This : IHTMLStyleSheetRule_Type)
     return Pointer_To_IHTMLRuleStyle
   is
       RetVal : aliased Pointer_To_IHTMLRuleStyle;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_style
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_style;

   function Get_readOnly
     (This : IHTMLStyleSheetRule_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_readOnly
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_readOnly;

end MSHTML.IHTMLStyleSheetRule_Interface;

